<template>
    <div>
        <div class="blankpage-form-field">
            <div class="page-logo m-0 w-100 align-items-center justify-content-center rounded border-bottom-left-radius-0 border-bottom-right-radius-0 px-4">
                <div class="col-md-6">
                    <a href="javascript:void(0)" class="page-logo-link press-scale-down d-flex align-items-center">
                        <img src="img/Sapfonte-logo-tran70.png" alt="Sapfonte" style="width:120px" aria-roledescription="logo">
                    </a>
                </div>
                <div class="col-md-6 pr-0">
                    <button v-if="checked" type="button" class="btn btn-primary float-right btn-sm" @click="openModal('codeModal')">Use login code</button>
                </div>
            </div>
            <div class="card p-4 border-top-left-radius-0 border-top-right-radius-0">
                <div class="form-group">
                    <label class="form-label" for="email">Email</label> <span style="color:red">*</span>
                    <input type="email" v-model="user.username" name="email" class="form-control" 
                        :class="{ 'is-invalid': user.errors.has('username') }" id="email" 
                        placeholder="Enter your email" value="">
                    <div class="invalid-feedback">No, you missed this one.</div>
                    <has-error :form="user" field="username"></has-error>
                </div>
                <div class="form-group">
                    <label class="form-label" for="password">Password</label> <span style="color:red">*</span>
                    <input type="password" id="password" name="password" class="form-control"
                        placeholder="Enter your password" value="" v-model="user.password"
                        :class="{ 'is-invalid': user.errors.has('password') }" >
                    <has-error :form="user" field="password"></has-error>
                </div>
                <div class="form-group text-left">
                    <div class="custom-control custom-checkbox">
                        <input type="checkbox" v-model="user.remember" name="remember" class="custom-control-input" id="rememberme">
                        <label class="custom-control-label" for="rememberme"> Remember me</label>
                    </div>
                </div>
                <button type="button" class="btn btn-primary float-right" @click="login">Login</button>
            </div>
            <div class="blankpage-footer text-center">
                <a href="javascript:void(0)" @click="openModal('forgotModal')"><strong>Forgot Password?</strong></a> | <router-link to="/register"><strong>Register Account</strong></router-link>
            </div>
        </div>
        <video poster="img/backgrounds/clouds.png" id="bgvid" playsinline autoplay muted loop>
            <source src="media/video/cc.webm" type="video/webm">
            <source src="media/video/cc.mp4" type="video/mp4">
        </video>
        <!-- code modal -->
        <div class="modal fade" id="codeModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLongTitle">Enter code </h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <h3>A code was sent to your email</h3>
                    <h3>It expires in <span id="countdown"></span></h3>
                    <div class="form-group">
                        <input type="text" name="code" class="form-control" id="code" 
                            placeholder="Enter the code here" value="">
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-primary" @click="validateCode()">Next</button>
                </div>
                </div>
            </div>
        </div>
        <!-- forgot password modal -->
        <div class="modal fade" id="forgotModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLongTitle">Forgot Password? </h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <h3>Ener an email to get the reset password link :</h3>
                    <div class="form-group">
                        <input type="email" name="username" class="form-control" id="username" 
                            placeholder="Enter the email here" value="">
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-primary" @click="sendResetPasswordLink()">Next</button>
                </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: 'Login',
        data() {
            return {
                user: new this.$Form ({
                    username: '',
                    password: '',
                }),
                validationData: {},
                checked:false
            }
        },
        methods: {
            login(){
                this.$store.dispatch('auth/user_login' , this.user)
                .then(() => {
                    this.checked = true
                    this.openModal('codeModal')
                    var seconds = this.$store.getters['auth/totp_time'], $seconds = document.querySelector('#countdown');
                        (function countdown() {
                            $seconds.textContent = seconds + ' second' + (seconds == 1 ?  '' :  's')
                            if(seconds --> 0) setTimeout(countdown, 1000)
                        })();
                })
                .catch(() => {
                    this.$Toast.fire({
                        icon: 'error',
                        title: 'Login failed'
                    })
                }) 
            },
            openModal(modal){
                this.$$(`#${modal}`).modal('show')
            },
            validateCode(){
                localStorage.setItem("device_id", this.$session.id())
                this.validationData = {
                        "username" : this.user.username,
                        "totp" : document.getElementById("code").value,
                        "device_id": this.$session.id(),
                        "device_name": "chrome",
                        "location": "kathmandu"
                    }
                this.$store.dispatch('auth/validate' , this.validationData)
                .then(() => {
                    this.checked = false
                    this.$$('#codeModal').modal('hide')
                    this.$router.push('/index')
                })
            },
            sendResetPasswordLink(){
                let data = {
                        "username" : document.getElementById("username").value
                    }
                    console.log(data)
                this.$store.dispatch('auth/sendResetPasswordLink' , data)
                .then(() => {
                    this.$$('#forgotModal').modal('hide')
                    this.$Swal.fire({
                        title: 'The password reset link was sent to your email.',
                        icon: 'success',
                        showCancelButton: false,
                        confirmButtonColor: '#3085d6',
                        cancelButtonColor: '#d33',
                        confirmButtonText: 'OK',
                        showLoaderOnConfirm: true,
                    })
                })
            }
        }
    }
</script>

<style scoped>

</style>